git-filter-branch.shon commit submodule.c: report the submodule that an error occurs in (ba95d4e)
   1#!/bin/sh
   2#
   3# Rewrite revision history
   4# Copyright (c) Petr Baudis, 2006
   5# Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
   6#
   7# Lets you rewrite the revision history of the current branch, creating
   8# a new branch. You can specify a number of filters to modify the commits,
   9# files and trees.
  10
  11# The following functions will also be available in the commit filter:
  12
  13functions=$(cat << \EOF
  14warn () {
  15        echo "$*" >&2
  16}
  17
  18map()
  19{
  20        # if it was not rewritten, take the original
  21        if test -r "$workdir/../map/$1"
  22        then
  23                cat "$workdir/../map/$1"
  24        else
  25                echo "$1"
  26        fi
  27}
  28
  29# if you run 'skip_commit "$@"' in a commit filter, it will print
  30# the (mapped) parents, effectively skipping the commit.
  31
  32skip_commit()
  33{
  34        shift;
  35        while [ -n "$1" ];
  36        do
  37                shift;
  38                map "$1";
  39                shift;
  40        done;
  41}
  42
  43# if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
  44# it will skip commits that leave the tree untouched, commit the other.
  45git_commit_non_empty_tree()
  46{
  47        if test $# = 3 && test "$1" = $(git rev-parse "$3^{tree}"); then
  48                map "$3"
  49        elif test $# = 1 && test "$1" = 4b825dc642cb6eb9a060e54bf8d69288fbee4904; then
  50                :
  51        else
  52                git commit-tree "$@"
  53        fi
  54}
  55# override die(): this version puts in an extra line break, so that
  56# the progress is still visible
  57
  58die()
  59{
  60        echo >&2
  61        echo "$*" >&2
  62        exit 1
  63}
  64EOF
  65)
  66
  67eval "$functions"
  68
  69finish_ident() {
  70        # Ensure non-empty id name.
  71        echo "case \"\$GIT_$1_NAME\" in \"\") GIT_$1_NAME=\"\${GIT_$1_EMAIL%%@*}\" && export GIT_$1_NAME;; esac"
  72        # And make sure everything is exported.
  73        echo "export GIT_$1_NAME"
  74        echo "export GIT_$1_EMAIL"
  75        echo "export GIT_$1_DATE"
  76}
  77
  78set_ident () {
  79        parse_ident_from_commit author AUTHOR committer COMMITTER
  80        finish_ident AUTHOR
  81        finish_ident COMMITTER
  82}
  83
  84USAGE="[--setup <command>] [--subdirectory-filter <directory>] [--env-filter <command>]
  85        [--tree-filter <command>] [--index-filter <command>]
  86        [--parent-filter <command>] [--msg-filter <command>]
  87        [--commit-filter <command>] [--tag-name-filter <command>]
  88        [--original <namespace>]
  89        [-d <directory>] [-f | --force] [--state-branch <branch>]
  90        [--] [<rev-list options>...]"
  91
  92OPTIONS_SPEC=
  93. git-sh-setup
  94
  95if [ "$(is_bare_repository)" = false ]; then
  96        require_clean_work_tree 'rewrite branches'
  97fi
  98
  99tempdir=.git-rewrite
 100filter_setup=
 101filter_env=
 102filter_tree=
 103filter_index=
 104filter_parent=
 105filter_msg=cat
 106filter_commit=
 107filter_tag_name=
 108filter_subdir=
 109state_branch=
 110orig_namespace=refs/original/
 111force=
 112prune_empty=
 113remap_to_ancestor=
 114while :
 115do
 116        case "$1" in
 117        --)
 118                shift
 119                break
 120                ;;
 121        --force|-f)
 122                shift
 123                force=t
 124                continue
 125                ;;
 126        --remap-to-ancestor)
 127                # deprecated ($remap_to_ancestor is set now automatically)
 128                shift
 129                remap_to_ancestor=t
 130                continue
 131                ;;
 132        --prune-empty)
 133                shift
 134                prune_empty=t
 135                continue
 136                ;;
 137        -*)
 138                ;;
 139        *)
 140                break;
 141        esac
 142
 143        # all switches take one argument
 144        ARG="$1"
 145        case "$#" in 1) usage ;; esac
 146        shift
 147        OPTARG="$1"
 148        shift
 149
 150        case "$ARG" in
 151        -d)
 152                tempdir="$OPTARG"
 153                ;;
 154        --setup)
 155                filter_setup="$OPTARG"
 156                ;;
 157        --subdirectory-filter)
 158                filter_subdir="$OPTARG"
 159                remap_to_ancestor=t
 160                ;;
 161        --env-filter)
 162                filter_env="$OPTARG"
 163                ;;
 164        --tree-filter)
 165                filter_tree="$OPTARG"
 166                ;;
 167        --index-filter)
 168                filter_index="$OPTARG"
 169                ;;
 170        --parent-filter)
 171                filter_parent="$OPTARG"
 172                ;;
 173        --msg-filter)
 174                filter_msg="$OPTARG"
 175                ;;
 176        --commit-filter)
 177                filter_commit="$functions; $OPTARG"
 178                ;;
 179        --tag-name-filter)
 180                filter_tag_name="$OPTARG"
 181                ;;
 182        --original)
 183                orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
 184                ;;
 185        --state-branch)
 186                state_branch="$OPTARG"
 187                ;;
 188        *)
 189                usage
 190                ;;
 191        esac
 192done
 193
 194case "$prune_empty,$filter_commit" in
 195,)
 196        filter_commit='git commit-tree "$@"';;
 197t,)
 198        filter_commit="$functions;"' git_commit_non_empty_tree "$@"';;
 199,*)
 200        ;;
 201*)
 202        die "Cannot set --prune-empty and --commit-filter at the same time"
 203esac
 204
 205case "$force" in
 206t)
 207        rm -rf "$tempdir"
 208;;
 209'')
 210        test -d "$tempdir" &&
 211                die "$tempdir already exists, please remove it"
 212esac
 213orig_dir=$(pwd)
 214mkdir -p "$tempdir/t" &&
 215tempdir="$(cd "$tempdir"; pwd)" &&
 216cd "$tempdir/t" &&
 217workdir="$(pwd)" ||
 218die ""
 219
 220# Remove tempdir on exit
 221trap 'cd "$orig_dir"; rm -rf "$tempdir"' 0
 222
 223ORIG_GIT_DIR="$GIT_DIR"
 224ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
 225ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
 226ORIG_GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME"
 227ORIG_GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL"
 228ORIG_GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE"
 229ORIG_GIT_COMMITTER_NAME="$GIT_COMMITTER_NAME"
 230ORIG_GIT_COMMITTER_EMAIL="$GIT_COMMITTER_EMAIL"
 231ORIG_GIT_COMMITTER_DATE="$GIT_COMMITTER_DATE"
 232
 233GIT_WORK_TREE=.
 234export GIT_DIR GIT_WORK_TREE
 235
 236# Make sure refs/original is empty
 237git for-each-ref > "$tempdir"/backup-refs || exit
 238while read sha1 type name
 239do
 240        case "$force,$name" in
 241        ,$orig_namespace*)
 242                die "Cannot create a new backup.
 243A previous backup already exists in $orig_namespace
 244Force overwriting the backup with -f"
 245        ;;
 246        t,$orig_namespace*)
 247                git update-ref -d "$name" $sha1
 248        ;;
 249        esac
 250done < "$tempdir"/backup-refs
 251
 252# The refs should be updated if their heads were rewritten
 253git rev-parse --no-flags --revs-only --symbolic-full-name \
 254        --default HEAD "$@" > "$tempdir"/raw-heads || exit
 255sed -e '/^^/d' "$tempdir"/raw-heads >"$tempdir"/heads
 256
 257test -s "$tempdir"/heads ||
 258        die "You must specify a ref to rewrite."
 259
 260GIT_INDEX_FILE="$(pwd)/../index"
 261export GIT_INDEX_FILE
 262
 263# map old->new commit ids for rewriting parents
 264mkdir ../map || die "Could not create map/ directory"
 265
 266if test -n "$state_branch"
 267then
 268        state_commit=$(git rev-parse --no-flags --revs-only "$state_branch")
 269        if test -n "$state_commit"
 270        then
 271                echo "Populating map from $state_branch ($state_commit)" 1>&2
 272                perl -e'open(MAP, "-|", "git show $ARGV[0]:filter.map") or die;
 273                        while (<MAP>) {
 274                                m/(.*):(.*)/ or die;
 275                                open F, ">../map/$1" or die;
 276                                print F "$2" or die;
 277                                close(F) or die;
 278                        }
 279                        close(MAP) or die;' "$state_commit" \
 280                                || die "Unable to load state from $state_branch:filter.map"
 281        else
 282                echo "Branch $state_branch does not exist. Will create" 1>&2
 283        fi
 284fi
 285
 286# we need "--" only if there are no path arguments in $@
 287nonrevs=$(git rev-parse --no-revs "$@") || exit
 288if test -z "$nonrevs"
 289then
 290        dashdash=--
 291else
 292        dashdash=
 293        remap_to_ancestor=t
 294fi
 295
 296git rev-parse --revs-only "$@" >../parse
 297
 298case "$filter_subdir" in
 299"")
 300        eval set -- "$(git rev-parse --sq --no-revs "$@")"
 301        ;;
 302*)
 303        eval set -- "$(git rev-parse --sq --no-revs "$@" $dashdash \
 304                "$filter_subdir")"
 305        ;;
 306esac
 307
 308git rev-list --reverse --topo-order --default HEAD \
 309        --parents --simplify-merges --stdin "$@" <../parse >../revs ||
 310        die "Could not get the commits"
 311commits=$(wc -l <../revs | tr -d " ")
 312
 313test $commits -eq 0 && die "Found nothing to rewrite"
 314
 315# Rewrite the commits
 316report_progress ()
 317{
 318        if test -n "$progress" &&
 319                test $git_filter_branch__commit_count -gt $next_sample_at
 320        then
 321                count=$git_filter_branch__commit_count
 322
 323                now=$(date +%s)
 324                elapsed=$(($now - $start_timestamp))
 325                remaining=$(( ($commits - $count) * $elapsed / $count ))
 326                if test $elapsed -gt 0
 327                then
 328                        next_sample_at=$(( ($elapsed + 1) * $count / $elapsed ))
 329                else
 330                        next_sample_at=$(($next_sample_at + 1))
 331                fi
 332                progress=" ($elapsed seconds passed, remaining $remaining predicted)"
 333        fi
 334        printf "\rRewrite $commit ($count/$commits)$progress    "
 335}
 336
 337git_filter_branch__commit_count=0
 338
 339progress= start_timestamp=
 340if date '+%s' 2>/dev/null | grep -q '^[0-9][0-9]*$'
 341then
 342        next_sample_at=0
 343        progress="dummy to ensure this is not empty"
 344        start_timestamp=$(date '+%s')
 345fi
 346
 347if test -n "$filter_index" ||
 348   test -n "$filter_tree" ||
 349   test -n "$filter_subdir"
 350then
 351        need_index=t
 352else
 353        need_index=
 354fi
 355
 356eval "$filter_setup" < /dev/null ||
 357        die "filter setup failed: $filter_setup"
 358
 359while read commit parents; do
 360        git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
 361
 362        report_progress
 363
 364        case "$filter_subdir" in
 365        "")
 366                if test -n "$need_index"
 367                then
 368                        GIT_ALLOW_NULL_SHA1=1 git read-tree -i -m $commit
 369                fi
 370                ;;
 371        *)
 372                # The commit may not have the subdirectory at all
 373                err=$(GIT_ALLOW_NULL_SHA1=1 \
 374                      git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
 375                        if ! git rev-parse -q --verify $commit:"$filter_subdir"
 376                        then
 377                                rm -f "$GIT_INDEX_FILE"
 378                        else
 379                                echo >&2 "$err"
 380                                false
 381                        fi
 382                }
 383        esac || die "Could not initialize the index"
 384
 385        GIT_COMMIT=$commit
 386        export GIT_COMMIT
 387        git cat-file commit "$commit" >../commit ||
 388                die "Cannot read commit $commit"
 389
 390        eval "$(set_ident <../commit)" ||
 391                die "setting author/committer failed for commit $commit"
 392        eval "$filter_env" < /dev/null ||
 393                die "env filter failed: $filter_env"
 394
 395        if [ "$filter_tree" ]; then
 396                git checkout-index -f -u -a ||
 397                        die "Could not checkout the index"
 398                # files that $commit removed are now still in the working tree;
 399                # remove them, else they would be added again
 400                git clean -d -q -f -x
 401                eval "$filter_tree" < /dev/null ||
 402                        die "tree filter failed: $filter_tree"
 403
 404                (
 405                        git diff-index -r --name-only --ignore-submodules $commit -- &&
 406                        git ls-files --others
 407                ) > "$tempdir"/tree-state || exit
 408                git update-index --add --replace --remove --stdin \
 409                        < "$tempdir"/tree-state || exit
 410        fi
 411
 412        eval "$filter_index" < /dev/null ||
 413                die "index filter failed: $filter_index"
 414
 415        parentstr=
 416        for parent in $parents; do
 417                for reparent in $(map "$parent"); do
 418                        case "$parentstr " in
 419                        *" -p $reparent "*)
 420                                ;;
 421                        *)
 422                                parentstr="$parentstr -p $reparent"
 423                                ;;
 424                        esac
 425                done
 426        done
 427        if [ "$filter_parent" ]; then
 428                parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
 429                                die "parent filter failed: $filter_parent"
 430        fi
 431
 432        {
 433                while IFS='' read -r header_line && test -n "$header_line"
 434                do
 435                        # skip header lines...
 436                        :;
 437                done
 438                # and output the actual commit message
 439                cat
 440        } <../commit |
 441                eval "$filter_msg" > ../message ||
 442                        die "msg filter failed: $filter_msg"
 443
 444        if test -n "$need_index"
 445        then
 446                tree=$(git write-tree)
 447        else
 448                tree=$(git rev-parse "$commit^{tree}")
 449        fi
 450        workdir=$workdir @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
 451                "$tree" $parentstr < ../message > ../map/$commit ||
 452                        die "could not write rewritten commit"
 453done <../revs
 454
 455# If we are filtering for paths, as in the case of a subdirectory
 456# filter, it is possible that a specified head is not in the set of
 457# rewritten commits, because it was pruned by the revision walker.
 458# Ancestor remapping fixes this by mapping these heads to the unique
 459# nearest ancestor that survived the pruning.
 460
 461if test "$remap_to_ancestor" = t
 462then
 463        while read ref
 464        do
 465                sha1=$(git rev-parse "$ref"^0)
 466                test -f "$workdir"/../map/$sha1 && continue
 467                ancestor=$(git rev-list --simplify-merges -1 "$ref" "$@")
 468                test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
 469        done < "$tempdir"/heads
 470fi
 471
 472# Finally update the refs
 473
 474_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 475_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
 476echo
 477while read ref
 478do
 479        # avoid rewriting a ref twice
 480        test -f "$orig_namespace$ref" && continue
 481
 482        sha1=$(git rev-parse "$ref"^0)
 483        rewritten=$(map $sha1)
 484
 485        test $sha1 = "$rewritten" &&
 486                warn "WARNING: Ref '$ref' is unchanged" &&
 487                continue
 488
 489        case "$rewritten" in
 490        '')
 491                echo "Ref '$ref' was deleted"
 492                git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
 493                        die "Could not delete $ref"
 494        ;;
 495        $_x40)
 496                echo "Ref '$ref' was rewritten"
 497                if ! git update-ref -m "filter-branch: rewrite" \
 498                                        "$ref" $rewritten $sha1 2>/dev/null; then
 499                        if test $(git cat-file -t "$ref") = tag; then
 500                                if test -z "$filter_tag_name"; then
 501                                        warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
 502                                        warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
 503                                fi
 504                        else
 505                                die "Could not rewrite $ref"
 506                        fi
 507                fi
 508        ;;
 509        *)
 510                # NEEDSWORK: possibly add -Werror, making this an error
 511                warn "WARNING: '$ref' was rewritten into multiple commits:"
 512                warn "$rewritten"
 513                warn "WARNING: Ref '$ref' points to the first one now."
 514                rewritten=$(echo "$rewritten" | head -n 1)
 515                git update-ref -m "filter-branch: rewrite to first" \
 516                                "$ref" $rewritten $sha1 ||
 517                        die "Could not rewrite $ref"
 518        ;;
 519        esac
 520        git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
 521                 exit
 522done < "$tempdir"/heads
 523
 524# TODO: This should possibly go, with the semantics that all positive given
 525#       refs are updated, and their original heads stored in refs/original/
 526# Filter tags
 527
 528if [ "$filter_tag_name" ]; then
 529        git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
 530        while read sha1 type ref; do
 531                ref="${ref#refs/tags/}"
 532                # XXX: Rewrite tagged trees as well?
 533                if [ "$type" != "commit" -a "$type" != "tag" ]; then
 534                        continue;
 535                fi
 536
 537                if [ "$type" = "tag" ]; then
 538                        # Dereference to a commit
 539                        sha1t="$sha1"
 540                        sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
 541                fi
 542
 543                [ -f "../map/$sha1" ] || continue
 544                new_sha1="$(cat "../map/$sha1")"
 545                GIT_COMMIT="$sha1"
 546                export GIT_COMMIT
 547                new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
 548                        die "tag name filter failed: $filter_tag_name"
 549
 550                echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
 551
 552                if [ "$type" = "tag" ]; then
 553                        new_sha1=$( ( printf 'object %s\ntype commit\ntag %s\n' \
 554                                                "$new_sha1" "$new_ref"
 555                                git cat-file tag "$ref" |
 556                                sed -n \
 557                                    -e '1,/^$/{
 558                                          /^object /d
 559                                          /^type /d
 560                                          /^tag /d
 561                                        }' \
 562                                    -e '/^-----BEGIN PGP SIGNATURE-----/q' \
 563                                    -e 'p' ) |
 564                                git hash-object -t tag -w --stdin) ||
 565                                die "Could not create new tag object for $ref"
 566                        if git cat-file tag "$ref" | \
 567                           sane_grep '^-----BEGIN PGP SIGNATURE-----' >/dev/null 2>&1
 568                        then
 569                                warn "gpg signature stripped from tag object $sha1t"
 570                        fi
 571                fi
 572
 573                git update-ref "refs/tags/$new_ref" "$new_sha1" ||
 574                        die "Could not write tag $new_ref"
 575        done
 576fi
 577
 578unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
 579unset GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 580unset GIT_COMMITTER_NAME GIT_COMMITTER_EMAIL GIT_COMMITTER_DATE
 581test -z "$ORIG_GIT_DIR" || {
 582        GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
 583}
 584test -z "$ORIG_GIT_WORK_TREE" || {
 585        GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
 586        export GIT_WORK_TREE
 587}
 588test -z "$ORIG_GIT_INDEX_FILE" || {
 589        GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
 590        export GIT_INDEX_FILE
 591}
 592test -z "$ORIG_GIT_AUTHOR_NAME" || {
 593        GIT_AUTHOR_NAME="$ORIG_GIT_AUTHOR_NAME" &&
 594        export GIT_AUTHOR_NAME
 595}
 596test -z "$ORIG_GIT_AUTHOR_EMAIL" || {
 597        GIT_AUTHOR_EMAIL="$ORIG_GIT_AUTHOR_EMAIL" &&
 598        export GIT_AUTHOR_EMAIL
 599}
 600test -z "$ORIG_GIT_AUTHOR_DATE" || {
 601        GIT_AUTHOR_DATE="$ORIG_GIT_AUTHOR_DATE" &&
 602        export GIT_AUTHOR_DATE
 603}
 604test -z "$ORIG_GIT_COMMITTER_NAME" || {
 605        GIT_COMMITTER_NAME="$ORIG_GIT_COMMITTER_NAME" &&
 606        export GIT_COMMITTER_NAME
 607}
 608test -z "$ORIG_GIT_COMMITTER_EMAIL" || {
 609        GIT_COMMITTER_EMAIL="$ORIG_GIT_COMMITTER_EMAIL" &&
 610        export GIT_COMMITTER_EMAIL
 611}
 612test -z "$ORIG_GIT_COMMITTER_DATE" || {
 613        GIT_COMMITTER_DATE="$ORIG_GIT_COMMITTER_DATE" &&
 614        export GIT_COMMITTER_DATE
 615}
 616
 617if test -n "$state_branch"
 618then
 619        echo "Saving rewrite state to $state_branch" 1>&2
 620        state_blob=$(
 621                perl -e'opendir D, "../map" or die;
 622                        open H, "|-", "git hash-object -w --stdin" or die;
 623                        foreach (sort readdir(D)) {
 624                                next if m/^\.\.?$/;
 625                                open F, "<../map/$_" or die;
 626                                chomp($f = <F>);
 627                                print H "$_:$f\n" or die;
 628                        }
 629                        close(H) or die;' || die "Unable to save state")
 630        state_tree=$(/bin/echo -e "100644 blob $state_blob\tfilter.map" | git mktree)
 631        if test -n "$state_commit"
 632        then
 633                state_commit=$(/bin/echo "Sync" | git commit-tree "$state_tree" -p "$state_commit")
 634        else
 635                state_commit=$(/bin/echo "Sync" | git commit-tree "$state_tree" )
 636        fi
 637        git update-ref "$state_branch" "$state_commit"
 638fi
 639
 640cd "$orig_dir"
 641rm -rf "$tempdir"
 642
 643trap - 0
 644
 645if [ "$(is_bare_repository)" = false ]; then
 646        git read-tree -u -m HEAD || exit
 647fi
 648
 649exit 0